<template>
    <div>
        <p v-bind:class="color">
            {{msg}}
        </p>
        <ProviderForm v-bind:provider="provider" v-bind:companies="companies" v-on:submit="edit()" v-on:back="back()" v-on:remove="remove">
    
        </ProviderForm>
    </div>
</template>

<script>

import ProviderForm from './Provider.Form.vue'
import {
    editProvider, deleteProvider
} from '@/api/providers.service.js'
export default {
    computed: {
        companies() {
            return this.$store.getters.getAllCompanies;
        },
        provider(){
            return this.$store.getters.getCurrentProvider;
        }
    },
    data() {
        return {
            confirm: "",
            interact: true,
            color: "black",
            msg: ""
        }
    },
    methods: {
        edit: function () {
            editProvider(this.provider._id, this.provider).then((response) => {
                this.$router.go(-1);
            }).catch((error) => {
                console.log(error);
                this.msg = "une erreur s'est produite, Veuillez réssayez";
                this.color = "red";
            });
        },
        back: function () {
            this.$router.go(-1);
        },
        remove() {
            deleteProvider(this.provider._id).then((response) => {
                this.$router.go(-1);
            }).catch((error) => {
                console.log(error);
                this.msg = "une erreur s'est produite, Veuillez réssayez";
                this.color = "red";
            });
        }
    }, components: {
        ProviderForm
    },
    created() {
        this.$store.dispatch('setProviderById', this.$route.params.id);
        this.$store.dispatch('setAllCompanies');
    }
}
</script>

<style scoped>
.black {
    color: black;
}

.red {
    color: red;
}
</style>
